// ********************************************************************************
// utility actionscript: spacebox client interaction
// mathias ochsendorf  : ochsendorf@hbt.arch.ethz.ch
// october 2004
// ********************************************************************************


// public  methods
// ---------------
//
// ********************************************************************************



// global variables and socket connections 
// ********************************************************************************


if (!_global.initialize) 
{
	trace("template is loaded");
	initialize	= true;
	osgiServer	= "styropor.ethz.ch";
	osgiPort	= 4445;
	osgiPrefix	= "";

	sockOsgi 		= new XMLSocket();
	sockOsgi.onXML		= onSockMessage;
	sockOsgi.onConnect	= onSockConnectOsgi;
	sockOsgi.onClose	= onSockCloseOsgi;
	sockOsgi.returnField 	= "\n ";
	sockOsgi.connect(osgiServer, osgiPort);
}


// background functionality
// ********************************************************************************

// connect to the server
function onSockConnectOsgi(success) 
{
	trace("onSockConnectOsgi connect to:" + osgiServer);
	if (success) 
	{
		trace ("connected to osgi server ");
	} else {
		trace ("connection to osgi server failed");
	}
}

// disconnection from the server
function onSockCloseOsgi() {
	trace ("lost connection to osgi server");
	trace("i am logging out");
	fscommand("quit");
	stop();
}

// send a message to the server
// @param array with the element ids
// @param the invoked method
// @param the value
function sendSockXML(myIDs, myMethod, myValue) {
	message = new XML();
	message_spacebox = message.createElement("spacebox");
	message_request  = message.createElement("request");

	for (i=0; i<myIDs.length; i++) {
		message_device = message.createElement("rcbox");
		message_id = message.createElement("id");
		id = message.createTextNode(myIDs[i]);
		message_id.appendChild(id);
		message_device.appendChild(message_id);
		message_method = message.createElement("method");
		method = message.createTextNode(myMethod);
		message_method.appendChild(method);
		message_device.appendChild(message_method);
		message_value = message.createElement("value");
		value = message.createTextNode(myValue);
		message_value.appendChild(value);
		message_device.appendChild(message_value);
		message_request.appendChild(message_device);
		//trace(message_device);
	}

	message_spacebox.appendChild(message_request);
	message.appendChild(message_spacebox);
	// trace(message.toString());
	sockOsgi.send(message);
}


// end *****************************************************************************end