// ********************************************************************************
// utility actionscript: spacebox tracking logic
// mathias ochsendorf  : ochsendorf@hbt.arch.ethz.ch
// november 2004
// ********************************************************************************

// read the standard logic actionscript:
#include "spacebox_logic.as"

// areas
_global.area1;
_global.area2;
_global.area3;
_global.area4;
_global.area5;
_global.area6;
_global.area7;
_global.area8;
_global.area9;


// public  methods
// ---------------

initAreas();

// init the 9 areas
// ********************************************************************************
function initAreas(){
	setArea(1);
	setArea(2);
	setArea(3);
	setArea(4);
	setArea(5);
	setArea(6);
	setArea(7);
	setArea(8);
	setArea(9);
	
}
function setArea(index){
	area = eval("area"+index);
	area.id = "ID:" + index;
	area.taken = 0;
	area._alpha = 20;
}

// react on server responses
// ********************************************************************************
// a message from the server received
function onSockMessage(xml_response) {
	// trace("onSockMessage:"+xml_response);
    processResponse(xml_response);
}

function processResponse(node){
	if( node.nodeName == osgiPrefix + "trackingSimple" )
	// || node.nodeName == osgiPrefix + "message" 
	// || node.nodeName == osgiPrefix + "rcbox" ) 
	{
		traverse_XML_message(node);
		//trace("bodycount: " + bodyCount);
		if(bodyCount != undefined){
			processTrackingInfo(bodyCount, lastArea);
		}
		return;
	}
	if(!node.hasChildNodes()) return;
	var n = node.firstChild;
	do{processResponse(n);} while(n = n.nextSibling);
}


// process tracking information
// ********************************************************************************
/*function processTrackingInfo() {
	for (var i:Number = 1; i<10; i++) {
		area  = eval("area"+i);
		//trace(area.id + ":" + area.taken);
		if( area.taken == 1 ) {
			areaNo = i;
			break;
		}
	}
	_root.onTrack( bodyCount, areaNo);
}*/
/*function processTrackingInfo(){
	// add functionality here
	for (var i:Number = 1; i<10; i++) {
		area  = eval("area"+i);
		trace(area.id + ":" + area.taken);
	}
}*/

// parse through a xml message
// ********************************************************************************
function traverse_XML_message(node){
  	if(!node.hasChildNodes()) return;
	//trace("traverse_XML_message");
    if(node.nodeName == osgiPrefix + "bodycount"){
    	bodyCount = String(node.firstChild.nodeValue);
    }
    if(node.nodeName == osgiPrefix + "area"){
    	updateArea(node);
    }
    
    // recursion:
    var n = node.firstChild;
    do{traverse_XML_message(n);} while(n = n.nextSibling);
}

// update area
// ********************************************************************************
function updateArea(node){
  	if(!node.hasChildNodes()) return;
	//trace("updateArea");
	if(node.nodeName == osgiPrefix + "id") 				areaID = String(node.firstChild.nodeValue)
	else if(node.nodeName == osgiPrefix + "taken") {
		areaTaken = String(node.firstChild.nodeValue);
		//trace("updateArea"+ areaID+" taken:" +areaTaken);
		eval("area"+areaID).taken = areaTaken;
		eval("area"+areaID)._alpha = 20 + 80*areaTaken;
		if( areaTaken == 1) 
			lastArea = areaID;
	}
	// recursion:
	var n = node.firstChild;
    do{updateArea(n);} while(n = n.nextSibling);

}

// simulate the broadcasting of information containing data of tracked persons
// ********************************************************************************
function trackingSimulation(number){
	//trace("trackingSimulation number: " + number);
	if(number == isNAN){
		return;
	}
	var message:String = String("<spacebox><tracking>");
	message += "<bodycount>" + number + "</bodycount>";
	for (var i:Number = 0; i<number; i++) {
		randomX = Math.round(Math.random() * 640 * 0.7);
		randomY = Math.round(Math.random() * 480 * 0.7);
		randomW = 100 + Math.round(Math.random() * 100);
		randomH = 100 + Math.round(Math.random() * 100);
		message += "<body><id>" + i + "</id>";
		message += "<x>"+ randomX +"</x>";
		message += "<y>"+ randomY +"</y>";
		message += "<width>"+ randomW +"</width>";
		message += "<height>"+ randomH +"</height>";
		message += "</body>";
	}
	message += "</tracking></spacebox>";
	//trace("trackingSimulation send:" + message);
	sockOsgi.send(message);
}
// end *****************************************************************************end